/* 
 * cs101.net.Wire
 *
 * Developed for "Rethinking CS101", a project of Lynn Andrea Stein's AP Group.
 * For more information, see <a href="http://www.ai.mit.edu/projects/cs101/">the
 * CS101 homepage</a> or email <las@ai.mit.edu>.
 *
 * Copyright (C) 1998 Massachusetts Institute of Technology.
 * Please do not redistribute without obtaining permission.
 */

package cs101.net;

/** 
 * A generic interface for stream-like things that can read and write
 * objects.
 *
 * <P>Copyright (c) 1998 Massachusetts Institute of Technology
 *
 * @author Todd C. Parnell, tpanrell@ai.mit.edu
 * @author Lynn Andrea Stein, las@ai.mite.du
 * @version $Id: Wire.java,v 1.1.1.1 2002/06/05 21:56:32 root Exp $
 */
public interface Wire {
  /** Read the next object.  Block if no object is available. */
  public Object readObject();
  
  /** Write an object.  Blocks if no space is available to write to */
  public void writeObject(Object obj);
}

/*
 * $Log: Wire.java,v $
 * Revision 1.1.1.1  2002/06/05 21:56:32  root
 * CS101 comes to Olin finally.
 *
 * Revision 1.6  1998/07/24 17:13:48  tparnell
 * Placate new javadoc behavior
 *
 * Revision 1.5  1998/07/22 18:18:10  tparnell
 * move from util to net
 *
 * Revision 1.4  1998/07/20 22:29:15  tparnell
 * added javadoc and logging
 *
 */



