/*
 * cs101 Stoppable interface
 * $Id: Stoppable.java,v 1.1.1.1 2002/06/05 21:56:32 root Exp $
 *
 * Developed for "Rethinking CS101", a project of Lynn Andrea Stein's AP Group.
 * For more information, see <a href="http://www.ai.mit.edu/projects/cs101/">the
 * CS101 homepage</a> or email <las@ai.mit.edu>.
 *
 * Copyright (C) 1999 Massachusetts Institute of Technology.
 * Please do not redistribute without obtaining permission.
 */
package cs101.util.gamecontrol;

/** 
 * Interface for an object with a stop() method.
 *
 * <P>Copyright (c) 1999 Massachusetts Institute of Technology
 *
 * @author Paul K. Njoroge, pnjoroge@mit.edu
 * @author Lynn Andrea Stein, las@ai.mit.edu
 * @version $Id: DefaultGameFrame.java
 */
public interface Stoppable
{
  public void stop();
}
 
/*
 * $Log: Stoppable.java,v $
 * Revision 1.1.1.1  2002/06/05 21:56:32  root
 * CS101 comes to Olin finally.
 *
 * Revision 1.1  2000/04/24 22:17:16  nathanw
 * Bulk reorganization
 *
 * Revision 1.1  1999/07/27 18:57:19  las
 * Patched up DefaultFrame (mostly docs) and DefaultGameFrame (aesthetics
 * and docs).
 *
 * Capitalized the name of the GameControllable interface.
 *
 * Moved the other four interfaces (Pausable, Resetable, Startable,
 * Stoppable) to cs101.util as they really have nothing to do w/awt or
 * windowing in particular.
 *
 * Also, added unpause() to Pausable as it doesn't make much sense to be
 * able to pause but not unpause something.
 *
 */
