package pnc;
import cs101.awt.DisplayField;

public
class Consumer extends Thread {
  private Buffer supply;
  private DisplayField display;
  private static int InstanceCount = 0;
  private static Object Lock = new Object();

  public Consumer(Buffer supply, DisplayField display) {
    this.supply = supply;
    this.display = display;
  }

  public void run() {
    synchronized(Lock) {
      this.InstanceCount++;
      // if this is the first producer waiting ...
      if (this.InstanceCount == 1) 
	this.display.changeState(false);

      this.display.setText(Integer.toString(this.InstanceCount));
      // tab over an approprate amount
      for (int i = 0; i<this.InstanceCount-1; i++) 
	System.out.print("    ");    
      System.out.println(this.InstanceCount + " consumer(s) started.");
    }

    // wait to see it
    try { Thread.sleep(250); } 
    catch (InterruptedException e) {}
    this.supply.consume();

    synchronized(Lock) {
      this.display.setText(Integer.toString(this.InstanceCount-1));
      // tab over an approprate amount
      for (int i = 0; i<this.InstanceCount-1; i++) 
	System.out.print("    ");
      System.out.println("Consumption complete.");
      this.InstanceCount--;

      // if none are left waiting ...
      if (this.InstanceCount == 0)
	this.display.changeState(true);

    }

  }

}























