package pnc;
import java.awt.*;
import java.util.*;
import cs101.awt.DisplayField;

public
abstract class NonInterPNC extends PNC {
  private Production pro;
  private Consumption con;  

  public void init() {  
    // call super class layout
    super.init();
    
    // Create production and consumption 
    pro = new Production(this.store, this.toProduce);
    con = new Consumption(this.store, this.toConsume);    
  }

  public void start() {
    super.start();
    
    // start the production and consumption 
    pro.start();
    con.start();

  }
 
}

class Production extends Thread {
  private Buffer storage;
  private DisplayField display;

  public Production(Buffer storage, DisplayField display) {
    this.storage = storage;
    this.display = display;
  }

  public void run() {
    Random randomizer = new Random(); 
    while (true) {
      // start a producer
      Producer maker = new Producer(this.storage, this.display);
      maker.start();
      
      // use the randomizer here to find a good amount to wait
      Float ran = new Float(randomizer.nextFloat()*5000);
      int wait = ran.intValue();

      // wait a random amount
      try { Thread.sleep(wait); } 
      catch (InterruptedException e) {}

    }
  }
}

class Consumption extends Thread {
  private Buffer supply;
  private DisplayField display;

  public Consumption(Buffer supply, DisplayField display) {
    this.supply = supply;
    this.display = display;
  }

  public void run() {
    Random randomizer = new Random(); 
    while (true) {
      // start a consumer
      Consumer unmaker = new Consumer(this.supply, this.display);
      unmaker.start();
     
      // use the randomizer here to find a good amount to wait
      Float ran = new Float(randomizer.nextFloat()*5000);
      int wait = ran.intValue();
      System.out.println("Wait " + wait);
      // wait a random amount
      try { Thread.sleep(wait); } 
      catch (InterruptedException e) {}

    }
  }
}






