// make some instance variables local instead
// remove underscores
// comment
// javadoc

package pnc;
import java.awt.*;
import java.applet.*;
import cs101.awt.DisplayField;

public
abstract class PNC extends Applet {
  protected Buffer store;
  protected DisplayField toProduce;
  protected DisplayField toConsume;


  public void init() { 

    // create components 
    if (this.store == null) // should be newed in subclass
      System.out.println("Subclass did not initialize buffer");

    this.toProduce = new DisplayField("0", true, Color.white,
				  Color.blue);
    this.toConsume = new DisplayField("0", true, Color.white,
				  Color.lightGray);

    // lay them out
    this.setBackground(Color.white);
    this.setForeground(Color.black);

    // top
    Panel topPanel = new Panel();
    topPanel.setLayout(new BorderLayout());
    topPanel.add("West",this.store.getWriteFlag());
    topPanel.add("East",this.store.getReadFlag());

    // center
    Panel centerPanel = new Panel();
    centerPanel.setLayout(new BorderLayout());
    Panel proPanel = new Panel();
    proPanel.add(new Label("Waiting to write"));
    proPanel.add(this.toProduce);
    Panel conPanel = new Panel();
    conPanel.add(new Label("Waiting to read"));
    conPanel.add(this.toConsume);       
    centerPanel.add("West",proPanel);
    centerPanel.add("East",conPanel);
    centerPanel.add("Center",this.store.getStoragePanel());
    
    // put it all together
    this.setLayout(new BorderLayout());
    this.add("North", topPanel);
    this.add("Center", centerPanel);

  }

}





















