package pnc;
import cs101.awt.DisplayField;

public
class Producer extends Thread {
  private Buffer storage;
  private DisplayField display;
  private static int InstanceCount = 0;
  private static Object Lock = new Object();

  public Producer(Buffer storage, DisplayField display) {
    this.storage = storage;
    this.display = display;
  }

  public void run() {
    synchronized(Lock) {
      this.InstanceCount++;
      // if this is the first producer waiting ...
      if (this.InstanceCount == 1)
	this.display.changeState(false);

      this.display.setText(Integer.toString(this.InstanceCount));
      // tab over an approprate amount
      for (int i = 0; i<this.InstanceCount-1; i++) 
	System.out.print("    ");    
      System.out.println(this.InstanceCount + " producer(s) started.");
    }

    // wait to see it
    try { Thread.sleep(250); } 
    catch (InterruptedException e) {}

    this.storage.produce();  
    
    synchronized(Lock) {
    this.display.setText(Integer.toString(this.InstanceCount-1));
    // tab over an approprate amount
    for (int i = 0; i<this.InstanceCount-1; i++) 
      System.out.print("    ");
    System.out.println("Production complete.");
    this.InstanceCount--;
    
    // if none are left waiting ...
    if (this.InstanceCount == 0)
      this.display.changeState(true);
    }

  }

}

